function [fname,fpath]=pfGetHSTFilenames(full_fname)

% check for file existence
[fpath,filename,fext,versn]=fileparts(full_fname);
if ~isempty(fpath)
%  disp('Path found')
  fpath=[fpath filesep];
else
%  disp('NO path found');
  fpath=[pwd filesep];
end


% *** replace this with (sub?) function to strip extensions
switch fext
  case '.xml'  % user has specified the .xml file
    % is it a vol.xml or a raw.xml?
    if strcmp(filename(end-2:end),'vol')
      fname.vol=[fpath filename];
      fname.xml=[fpath filename fext];
      [tmp,fname.prefix]=fileparts(filename(1:end-4));

    elseif strcmp(filename(end-2:end),'raw')
      fname.raw=[fpath filename];
      fname.info=[fpath filename '.info'];
      [tmp,fname.prefix]=fileparts(filename(1:end-4));
    end

  case '.vol'  % user has specified the .vol file
    fname.vol=[fpath filename fext];
    fname.xml=[fpath filename fext '.xml'];
    [tmp,fname.prefix]=fileparts(filename);

  case '.raw'
    fname.raw=[fpath filename fext];
    fname.info=[fpath filename fext '.info'];
    [tmp,fname.prefix]=fileparts(filename);

  case '.info'  % could be either 8 or 32 bit
    disp('PLEASE SELECT .VOL or .RAW FILES ONLY')
    return
    fname.info=[filename '.info'];
    switch filename(end-2:end)
      case 'vol'
        disp('vol')
        fname.vol=filename;
        
      case 'raw'
        disp('raw')
        fname.raw=filename;
      otherwise
        disp('I am stuck - sorry!')
        return
    end
    
  otherwise  % user might have just specifed the file without extension
    % is it a 32 bit (.vol) or 8bit (.raw) volume?
    if exist([fpath filename '.vol'],'file')
      % 32 bit
      fname.vol=[fpath filename '.vol'];
      fname.xml=[fpath filename '.vol.xml'];
    elseif exist([fpath filename '.raw'],'file')
      fname.raw=[fpath filename '.raw'];
      fname.info=[fpath filename '.info'];
    else
      disp('No file found')
      
    end
    [tmp,fname.prefix]=fileparts(full_fname);
end
